package com.tptj.demo.hg.output.formula.provider;

import com.fanruan.api.log.LogKit;
import com.fr.intelli.record.Focus;
import com.fr.main.workbook.ResultWorkBook;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.schedule.base.bean.output.OutputEmail;
import com.fr.schedule.extension.report.job.output.formula.EmailFormula;
import java.util.List;
import java.util.Map;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-20
 * AbstractOutputFormulaProvider
 *      --> AbstractReportOutputFormulaProvider
 *              -->EmailFormula
 **/
@EnableMetrics
public class Demo extends EmailFormula {

    @Override
    @Focus(id="com.tptj.demo.hg.output.formula.provider.v10",text = "OutputFormulaProvider")
    public void dealWithFormulaParam(OutputEmail action, ResultWorkBook result, List<Map<String, Object>> mapList) throws Exception {
        //hugh:10.0版本定时附件处理过程中，只有在OutputFormulaProvider#dealWithFormulaParam接口中才能获取到结果报表，
        // 对要发送的信息进行处理，主要是处理公式和参数支持。将要发送的消息中需要的结果报表信息提前取出来生成好
        LogKit.info("可以在邮件信息OutputEmail生成之前，对结果报表进行预处理");
        super.dealWithFormulaParam(action, result, mapList);
        LogKit.info("可以在邮件信息OutputEmail生成之后，对邮件信息进行校正");
    }

}
