package com.tptj.demo.hg.output.formula.provider;

import com.fanruan.api.util.StringKit;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.stable.db.constant.EntityConstant;
import com.fr.stable.db.entity.TableAssociation;
import com.fr.third.javax.persistence.Column;
import com.fr.third.javax.persistence.Entity;
import com.fr.third.javax.persistence.Table;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-20
 * 插件中的表名必须以plugin开头
 **/
@Entity
@Table(name = "plugin_output_log")
@TableAssociation(associated = true)
public class LogEntity extends AbstractScheduleEntity {

    public static final String COLUMN_TERMINAL_TYPE = "terminal";
    public static final String COLUMN_SUBJECT = "subject";
    public static final String COLUMN_CONTENT = "content";
    public static final String COLUMN_LINK_OPEN_TYPE = "linkOpenType";
    public static final String COLUMN_CUSTOMIZE_LINK = "customizeLink";
    public static final String COLUMN_TYPE = "type";
    public static final String COLUMN_MEDIA_ID = "mediaId";
    public static final String COLUMN_PRE = "pre";

    @Column(name = COLUMN_PRE)
    private String pre = StringKit.EMPTY;

    @Column(name = COLUMN_TERMINAL_TYPE)
    private int terminal = 1;

    @Column(name = COLUMN_SUBJECT, length = EntityConstant.STRING_LONG_SIZE)
    private String subject;

    @Column(name = COLUMN_CONTENT, length = EntityConstant.STRING_LONG_SIZE)
    private String content;

    @Column(name = COLUMN_LINK_OPEN_TYPE)
    private int linkOpenType = -1;

    @Column(name = COLUMN_CUSTOMIZE_LINK, length = EntityConstant.STRING_LONG_SIZE)
    private String customizeLink;

    @Column(name = COLUMN_TYPE)
    private int type;

    @Column(name = COLUMN_MEDIA_ID)
    private String mediaId;

    @Override
    public OutputLog createBean() {
        return new OutputLog()
                .id(getId())
                .terminal(getTerminal())
                .subject(getSubject())
                .content(getContent())
                .customizeLink(getCustomizeLink())
                .linkOpenType(getLinkOpenType())
                .type(getType())
                .mediaId(getMediaId());
    }

    public String getPre() {
        return pre;
    }

    public void setPre(String pre) {
        this.pre = pre;
    }

    public int getTerminal() {
        return terminal;
    }

    public void setTerminal(int terminal) {
        this.terminal = terminal;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public int getLinkOpenType() {
        return linkOpenType;
    }

    public void setLinkOpenType(int linkOpenType) {
        this.linkOpenType = linkOpenType;
    }

    public String getCustomizeLink() {
        return customizeLink;
    }

    public void setCustomizeLink(String customizeLink) {
        this.customizeLink = customizeLink;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getMediaId() {
        return mediaId;
    }

    public void setMediaId(String mediaId) {
        this.mediaId = mediaId;
    }

    public LogEntity id(String id) {
        setId(id);
        return this;
    }

    public LogEntity terminal(int terminal) {
        setTerminal(terminal);
        return this;
    }

    public LogEntity subject(String subject) {
        setSubject(subject);
        return this;
    }

    public LogEntity content(String content) {
        setContent(content);
        return this;
    }

    public LogEntity linkOpenType(int linkOpenType) {
        setLinkOpenType(linkOpenType);
        return this;
    }

    public LogEntity customizeLink(String customizeLink) {
        setCustomizeLink(customizeLink);
        return this;
    }

    public LogEntity type(int type) {
        setType(type);
        return this;
    }

    public LogEntity mediaId(String mediaId) {
        setMediaId(mediaId);
        return this;
    }

    public LogEntity pre(String pre) {
        setPre(pre);
        return this;
    }
}
